魔戒(思维+bfs)

Description

蓝色空间号和万有引力号进入了四维水洼,发现了四维物体--魔戒。

这里我们把飞船和魔戒都抽象为四维空间中的一个点,分别标为 "S" 和 "E"。空间中可能存在障碍物,标为 "#",其他为可以通过的位置。

现在他们想要尽快到达魔戒进行探索,你能帮他们算出最小时间是最少吗?我们认为飞船每秒只能沿某个坐标轴方向移动一个单位,且不能越出四维空间。

Input

输入数据有多组(数据组数不超过 30),到 EOF 结束。

每组输入 4 个数 x, y, z, w 代表四维空间的尺寸(1 <= x, y, z, w <= 30)。

接下来的空间地图输入按照 x, y, z, w 轴的顺序依次给出,你只要按照下面的坐标关系循环读入即可。

for 0, x-1

for 0, y-1

for 0, z-1

for 0, w-1

保证 "S" 和 "E" 唯一。

Output

对于每组数据,输出一行,到达魔戒所需的最短时间。

如果无法到达,输出 "WTF"(不包括引号)。

Sample Input

2 2 2 2
..
.S
..
#.
#.
.E
.#
..
2 2 2 2
..
.S
#.
##
E.
.#
#.
..

Sample Output

1
3题解:其实四维空间博主也不太懂,这道题其实

 1 #include<cstdio>
 2 #include<cstring>
 3 #include<stack>
 4 #include<queue>
 5 #include<algorithm>
 6 #include<map>
 7 #include<vector>
 8 #define PI acos(-1.0)
 9 using namespace std;
10 #define Inf 0x3f3f3f3f
11 typedef long long ll;
12 int m,n,x,y,flag=0;
13 char str[45][45][45][45];
14 int visit[50][50][50][50];
15 int dis[500][500];
16 int di[8][4]= {{0,0,0,1},{0,0,0,-1},{0,0,1,0},{0,0,-1,0},{0,1,0,0},{0,-1,0,0},{1,0,0,0},{-1,0,0,0}};
17 map<ll,ll>::iterator it;
18 struct node
19 {
20     int x,y,z,w,step;
21 } ;
22 int bfs(int sx,int sy,int sz,int sw)
23 {
24     queue<node>pp;
25     node s,q;
26     s.x=sx;
27     s.y=sy;
28     s.z=sz;
29     s.w=sw;
30     s.step=0;
31     pp.push(s);
32     memset(visit,0,sizeof(visit));
33     visit[s.x][s.y][s.z][s.w]=1;
34     while(!pp.empty())
35     {
36         s=pp.front();
37         if(str[s.x][s.y][s.z][s.w]==‘E‘)
38         {
39             flag=0;
40             return s.step;
41         }
42         pp.pop();
43         for(int i=0; i<8; i++)
44         {
45             q.x=s.x+di[i][0];
46             q.y=s.y+di[i][1];
47             q.z=s.z+di[i][2];
48             q.w=s.w+di[i][3];
49             q.step=s.step;
50             if(q.x>=0&&q.x<m&&q.y>=0&&q.y<n&&q.z>=0&&q.z<x&&q.w>=0&&q.w<y&&!visit[q.x][q.y][q.z][q.w]&&str[q.x][q.y][q.z][q.w]!=‘#‘)
51             {
52                 q.step++;
53                 visit[q.x][q.y][q.z][q.w]=1;
54                 pp.push(q);
55             }
56         }
57     }
58 }
59 int main()
60 {
61     int z,w,sx,sy,sz,sw,i,j,ans;
62     while(scanf("%d%d%d%d",&m,&n,&x,&y)!=-1)
63     {
64         flag=1;
65         for(i=0; i<m; i++)
66             for(j=0; j<n; j++)
67                 for(z=0; z<x; z++)
68                     for(w=0; w<y; w++)
69                     {
70                         scanf(" %c",&str[i][j][z][w]);
71                         if(str[i][j][z][w]==‘S‘)
72                         {
73                             sx=i,sy=j,sz=z,sw=w;
74                         }
75
76                     }
77         ans=bfs(sx,sy,sz,sw);
78         if(flag)
79             puts("WTF");
80         else
81             printf("%d\n",ans);
82     }
83     return 0;
84 }

题意很简单从s->E的最短路,4维数组+bfs搜索一下就哦了,bfs裸题

原文地址:https://www.cnblogs.com/moomcake/p/9351174.html

时间: 2024-11-06 11:40:30

魔戒(思维+bfs)的相关文章

CF543B Destroying Roads 枚举 + 思维 + BFS

Code: #include <bits/stdc++.h> #define ll long long #define setIO(s) freopen(s".in","r",stdin) #define maxn 3002 using namespace std; queue<int>Q; vector<int>G[maxn]; int n,m,s1,t1,l1,s2,t2,l2; int vis[maxn],d[maxn][m

DFS/BFS+思维 HDOJ 5325 Crazy Bobo

题目传送门 1 /* 2 题意:给一个树,节点上有权值,问最多能找出多少个点满足在树上是连通的并且按照权值排序后相邻的点 3 在树上的路径权值都小于这两个点 4 DFS/BFS+思维:按照权值的大小,从小的到大的连有向边,搜索最多连接点数即是答案.因为排序后,他们之间的路径, 5 可定都是从当前节点u连过去的,那么都是小于这两个节点的.DFS需手动加栈,BFS类似拓扑排序的思路 6 */ 7 #pragma comment (linker, "/STACK:1024000000,10240000

Gym 100971A Treasure Island BFS 思维题

A - Treasure Island Time Limit:2000MS     Memory Limit:262144KB     64bit IO Format:%I64d & %I64u Submit Status Description standard input/output Announcement Statements Pirate John Silver has found a map depicting exactly one island in a sea. The ma

CodeForces 789E bfs建模,思维

CodeForces 789E 题意:有k种可乐,每种的测试为ai/1000. 要你合成一种浓度为n/1000的可乐,问最小要杯可乐,每种可乐可重复取. tags:  要注意到浓度绝不会超过1000/1000. 假设选取m杯可乐,则 (a1+a2+......+am) / m = n,变换一下为(a1-n)+(a2-n)+......+(am-n) = 0.即要选 m杯可乐,其浓度减 n之和为0.而浓度不超过1000,故(a1-n)+(a2-n)+....+(as-n)的和肯定在 -1000~1

小花梨判连通 (bfs+思维+map统计数量)

如果两个集合存储颜色的情况相同,说明这两个在k个图中都是在一个集合的 学到的点:用map,将vector映射一个整数时,只有vector后面的邻接的数据都一样时,才认为两个vector一样 代码: #include<cstdio> #include<cstring> #include<iostream> #include<algorithm> #include<queue> #include<stack> #include<ma

codeforces gym #101987B -Cosmetic Survey(建图+bfs思维)

题目链接: https://codeforces.com/gym/101987/attachments 题意: 给出$n$个节点,$m$条边 对于所有$(a,b)$,求出$a$到$b$路径中最小边的最大值 注意两个隐藏条件 1.不存在环 2.如果$a$到$b$,$b$到$c$,那么$len(a,b)>len(b,c)$ 数据范围: $1\leq n \leq 500$ $1\leq m \leq 250000$ 分析: 一条路径最小值 AC代码: #include<bits/stdc++.h&

hdu 4474 BFS+思维题

http://acm.hdu.edu.cn/showproblem.php?pid=4474 如果A%n ==B %n  (A<B) 那么A接下来A经若干次填位数使得A'%n==0,这个过程也可以使B'%n==0  但是显然A更小,所以开一个1e4的数组判重 犯得二逼错误: 1.需要记录每一位,不是mod%10就是每一位 2.第一位枚举1~9,但是仍然需要%n 3.必然需要高精度,开始ll  WA到死 #include <cstdio> #include <cstring>

CF788C The Great Mixing BFS+思维

这个模型十分巧妙啊,好题好题~ code: #include <bits/stdc++.h> #define N 3006 #define setIO(s) freopen(s".in","r",stdin) using namespace std; int n,k,vis[N],in[N],dp[N]; vector<int>v; queue<int>q; int main() { int i,j; // setIO("

uva 10047 uva live 2035 The Monocycle bfs

// uva 10047 uva live 2035 bfs // 求最短的嘛,肯定先尝试bfs啦 // 确定状态,首先状态里面得有坐标x,y // 还得有朝向,还得有颜色值 // // 这样就是一个状态里面有着三种属性 // 每个状态都只要经历一次,再经历是没有任何意义的 // 用一个que的思维数组记录就行了. // 按照方向爆搜,我先用f[i][j]记录的就是到 // 这一点的最小距离,但是怎么都过不了样例 // 突然明白了,如果只是这样记录最短距离,是不行的 // 因为每次从队列中取出的